<!DOCTYPE html>
<html>

<head lang="es">
	<meta charset="utf-8">
	<title>Trabajo en grupo TG3</title>
	<link rel="stylesheet" href="style.css">
	<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
		integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
	<script src="https://code.jquery.com/jquery-3.4.1.slim.min.js"
		integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n"
		crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
		integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo"
		crossorigin="anonymous"></script>
	<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"
		integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6"
		crossorigin="anonymous"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/clipboard.js/2.0.4/clipboard.min.js"></script>
</head>

<body>
	<nav class="navbar navbar-expand-lg fixed-top">
		<a class="navbar-brand" href="#">Desarrollo con tecnologías emergentes</a>
		<button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNavDropdown"
			aria-controls="navbarNavDropdown" aria-expanded="false" aria-label="Toggle navigation">
			<span class="navbar-toggler-icon"></span>
		</button>
		<div class="collapse navbar-collapse" id="navbarNavDropdown">
			<ul class="navbar-nav">
				<li class="nav-item dropdown">
					<a class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink" data-toggle="dropdown"
						aria-haspopup="true" aria-expanded="false">
						Índice
					</a>
					<div class="dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
						<a class="dropdown-item" href="#1">1. Informacion general</a>
						<a class="dropdown-item" href="#2">2. Requisitos de los prototipos a implementar</a>
						<a class="dropdown-item" href="#3">3. Criterios de comparacion de los prototipos</a>
						<a class="dropdown-item" href="#4">4. Implementación del prototipo con tecnología A</a>
						<a class="dropdown-item" href="#5">5. Implementación del prototipo con tecnología B</a>
						<a class="dropdown-item" href="#6">6. Comparacion de los prototipos</a>
						<a class="dropdown-item" href="#7">7. Conclusiones</a>
					</div>
				</li>
			</ul>
		</div>
	</nav>

	<div id="main" class="container-fluid" style="margin-top: 20px;">

		<div class="header">
			<p class="main-title text-center">
				Desarrollo con Tecnologias Emergentes. Curso 2019-20
			</p>
			<br>
			<p class="subtitle-main text-center">
				Trabajo TG3 del grupo T6
			</p>
			<br>
			<p class="subtitle-main text-center">
				TG3. Implementar dos tecnologias emergentes
			</p>
		</div>


		<span class="index-number" id="1"></span>
		<div class="content not-even-content">
			<div class="row justify-content-center">
				<div class="col-10">
					<h2 class="title-section">1. Informacion general</h2>
					<h3>1.1 Autores</h3>
					<p class="text-justify">
					<ul>
						<li>Cristobal Placencia - Product Owner</li>
						<li>Daniel Molina</li>
						<li>Carlos Gamero</li>
						<li>Adrián Sanz</li>
						<li>Daniel Villalobos</li>
					</ul>
					</p>
				</div>
				<div class="col-10">
					<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
					<p>
						Se crea un proyecto en gitlab <a href="https://gitlab.com/dte2020/t6/tg3"
							style="color: #2196F3 !important;"><span
								style="color: #2196F3 !important; font-weight: bold;">Accesible en este
								enlace</span></a>
						<br />
						<a data-toggle="modal" data-target="#boardModal" style="cursor: pointer;"><img height="256"
								width="512" src="./assets/boards.png" class="rounded"></a>
					<p>Hacer click para abrir más grande</p>
					<div id="boardModal" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel"
						aria-hidden="true">
						<div class="modal-dialog modal-dialog-centered">
							<div class="modal-content">
								<img height="512px" width="1024px" src="./assets/boards.png" class="img-responsive">
							</div>
						</div>
					</div>
					</p>

				</div>
				<div class="col-10">
					<h3>1.3 Burndown chart</h3>
					<a data-toggle="modal" data-target="#burnModal" style="cursor: pointer;"><img height="256"
							width="512" src="./assets/burndown.png" class="rounded"></a>
					<p>Hacer click para abrir más grande</p>
					<div id="burnModal" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel"
						aria-hidden="true">
						<div class="modal-dialog modal-dialog-centered">
							<div class="modal-content">
								<img height="512px" width="1024px" src="./assets/burndown.png" class="img-responsive">
							</div>
						</div>
					</div>
				</div>
				<div class="col-10">

					<h3>1.4 Presentacion del trabajo</h3>
					<p>
						En este apartado se debe incluir el enlace al archivo de la
						presentacion con diapositivas, ubicado en el repositorio del
						proyecto.
					</p>
					<button type="button" class="btn" style="background-color: #ef6c00;">
						<a href="./assets/tg3.pptx" style="color: white; text-decoration: none;">
							Enlace a la presentación
						</a>
					</button>

				</div>
			</div>

		</div>

		<span class="index-number" id="2"></span>
		<div class="content even-content">
			<div class="row justify-content-center">
				<div class="col-10">
					<h2 class="title-section">2. Requisitos de los prototipos a implementar</h2>
					<p class="text-justify">
						Para la elaboración de los prototipos, se decide realizar un programa que recupere información
						de diferentes sitios web relacionada con el coronavirus. Concretamente, se utilizará la página
						habilitada por el <a href="https://covid19.isciii.es/">Insituto de Salud Carlos III</a>, donde
						se recopila y ofrecen los datos en tiempo real que son enviados al ministerio de Sanidad.
						<br>
						Estos datos recopilados, ofrecen información actualizada por comunidad autonoma de:
					<ul>
						<li>Casos totales registrados</li>
						<li>Casos hospitalizados</li>
						<li>Casos totales en UCI</li>
						<li>Fallecidos totales</li>
						<li>Recuperaciones totales</li>
					</ul>
					<br>
					Estos datos son ofrecidos en formato CSV y agrupados por fecha.
					<br>
					Con esta información, se pretende realizar un prototipo que sea capaz de descargar los datos
					actualizados en formato CSV, y tras realizar las conversiones necesarias, ofrecerá medias,
					variaciones entre días y comparaciones de diferentes comunidades autónomas.
					<br>
					Los requisitos se dividen en requisitos funcionales básicos y requisitos funcionales deseados.
					Se
					considerará completo un prototipo que realice los requisitos básicos y se esperará que puedan
					ser completados los requisitos deseados.
					</p>
				</div>
				<div class="col-10">
					<h3>2.1 Manuales de instalación y funcionamiento en Kotlin</h3>
					<p class="text-justify">
						Para el funcionamiento y la codificación de los prototipos se decide utilizar el software
						orientado al desarrollo de entornos JVM de IntelliJ.
						Este Software es desarrollado integramente por la empresa JetBrains, creadores de Kotlin, por lo
						que se puede esperar el mejor soporte para este en el IDE.
						Además, mediante la instalación de plugins oficiales, es posible añadir soporte del lenguaje
						Scala en el mismo.
						Para la instalación y configuración serán necesarios los siguientes pasos.
					</p>
					<span class="paso">Paso 1: Instalación del JDK</span>
					<p class="text-justify">
						Para el correcto funcionamiento de Kotlin es necesario instalar el Java Development Kit.
						Para ello nos dirigimos al <a
							href="https://www.oracle.com/java/technologies/javase/javase-jdk8-downloads.html">siguiente
							enlace</a> donde podremos seleccionar la última versión disponible para nuestro sistema
						operativo.
					</p>
					<img src="./assets/JDK.png" class="responsive-images" />
					<p class="text-justify">
						Una vez descargado, procedemos a su instalación
					</p>
					<br>
					<span class="paso">Paso 2: Instalación del IDE</span>
					<p class="text-justify">
						Como ya se ha comentado, se utilizará el IDE IntelliJ para la realización y ejecución de los
						prototipos. Para ello, nos dirigimos a la <a
							href="https://www.jetbrains.com/es-es/idea/download/">pagina oficial de JetBrains</a> para
						proceder a su descarga.
						<br>
						<img src="./assets/IntelliJ.png" class="responsive-images" />
					<p>En este caso, la versión Community es suficiente para este proyecto, aunque si nos
						registramos
						con un correo de la Universidad de Alcalá tendremos disponible, tanto para esta como el
						resto de
						herramientas de JetBrains, la versión Ultimate durante un año, renovable mientras la cuenta
						de
						la universidad siga activa.</p>
					</p>
					<span class="paso">Paso 3: Soporte del lenguaje</span>
					<p class="text-justify">
						En el caso de Kotlin, no es necesario instalar nada ya que el lenguaje está soportado en el IDE.
					</p>
					<span class="paso">Paso 4: Instalación de dependencias</span>
					<p class="text-justify">
						Para la realización de los gráficos utilizaremos una librería denominada,
						<strong>tablesaw</strong>. En el caso de que el prototipo se vaya a ejecutar y no a codificar,
						no es necesario realiar este paso.
						<br>
						Esta librería debe ser instalada mediante un gestor de dependencias, en este caso utilizaremos
						Maven, ya que está soportado nativamente en IntelliJ.
						Comenzamos habilitando Maven en el proyecto, para ello en la vista de "Project" seleccionamos la
						opción "Add new framework" que nos aparecerá cuando hagamos click secundario en el nombre del
						proyecto.
						<br>
						<img src="./assets/Maven1.png" class="responsive-images" />
						<br>
						<br>
						Y buscamos en la lista por "Maven"
						<br>
						<br>
						<img src="./assets/Maven2.png" class="responsive-images" />
						<br>
						<br>
						Esto nos generará un fichero denomina "pom.xml" que nos permitirá gestionar las dependencias de
						nuestro proyecto.
						El cual debe tener un aspecto similar, una vez hayamos añadido la dependencia.
						<br>
						<br>
						<img src="./assets/Maven3.png" class="responsive-images" />
						<br>
						<br>
						El código de la dependencia se puede obtener con el siguiente botón, se debe pegar dentro de la
						parte de &lt;project&gt; -->
						<button class="to-copy" style="background-color: transparent; border: 0px;" data-clipboard-text="
						<dependencies>
							<dependency>
								<groupId>tech.tablesaw</groupId>
								<artifactId>tablesaw-core</artifactId>
								<version>0.38.0</version>
							</dependency>
							<dependency>
								<groupId>tech.tablesaw</groupId>
								<artifactId>tablesaw-jsplot</artifactId>
								<version>0.38.0</version>
							</dependency>
							<dependency>
								<groupId>org.jetbrains.kotlin</groupId>
								<artifactId>kotlin-stdlib-jdk8</artifactId>
								<version>${kotlin.version}</version>
							</dependency>
							<dependency>
								<groupId>org.jetbrains.kotlin</groupId>
								<artifactId>kotlin-test</artifactId>
								<version>${kotlin.version}</version>
								<scope>test</scope>
							</dependency>
							<dependency>
								<groupId>org.slf4j</groupId>
								<artifactId>slf4j-api</artifactId>
								<version>1.7.5</version>
							</dependency>
							<dependency>
								<groupId>org.slf4j</groupId>
								<artifactId>slf4j-log4j12</artifactId>
								<version>1.7.5</version>
							</dependency>
						</dependencies>">
							<kbd><kbd>ctrl</kbd> + <kbd>c</kbd></kbd>
						</button>
					<div class="toast" role="alert" aria-live="assertive" aria-atomic="true" data-delay=1000>
						<div class="toast-body" style="color:#333">
							Código copiado al portapapeles
						</div>
					</div>
					</p>
				</div>
				<div class="col-10">
					<h3>2.2 Manuales de instalación y funcionamiento en Scala</h3>
					<p class="text-justify">
						Para el funcionamiento y la codificación de los prototipos se decide utilizar el software
						orientado al desarrollo de entornos JVM de IntelliJ.
						Este Software es desarrollado integramente por la empresa JetBrains, creadores de Kotlin, por lo
						que se puede esperar el mejor soporte para este en el IDE.
						Además, mediante la instalación de plugins oficiales, es posible añadir soporte del lenguaje
						Scala en el mismo.
						Para la instalación y configuración serán necesarios los siguientes pasos.
					</p>
					<span class="paso">Paso 1: Instalación del JDK</span>
					<p class="text-justify">
						Para el correcto funcionamiento de Scala es necesario instalar el Java Development Kit.
						Para ello nos dirigimos al <a
							href="https://www.oracle.com/java/technologies/javase/javase-jdk8-downloads.html">siguiente
							enlace</a> donde podremos seleccionar la última versión disponible para nuestro sistema
						operativo.
					</p>
					<img src="./assets/JDK.png" class="responsive-images" />
					<p class="text-justify">
						Una vez descargado, procedemos a su instalación
					</p>
					<br>
					<span class="paso">Paso 2: Instalación del IDE</span>
					<p class="text-justify">
						Como ya se ha comentado, se utilizará el IDE IntelliJ para la realización y ejecución de los
						prototipos. Para ello, nos dirigimos a la <a
							hrf="https://www.jetbrains.com/es-es/idea/download/">pagina oficial de JetBrains</a> para
						proceder a su descarga.
						<br>
						<img src="./assets/IntelliJ.png" class="responsive-images" />
						En este caso, la versión Community es suficiente para este proyecto, aunque si nos registramos
						con un correo de la Universidad de Alcalá tendremos disponible, tanto para esta como el resto de
						herramientas de JetBrains, la versión Ultimate durante un año, renovable mientras la cuenta de
						la universidad siga activa.
					</p>
					<span class="paso">Paso 3: Soporte del lenguaje</span>
					<p class="text-justify">
						Para poder usar Scala dentro de un proyecto de IntelliJ, deberemos instalar su plugin oficial.
						Para ello, en la ventana de creación de proyecto seleccionamos la opción "Configure" y dentro
						del menú la opción "Plugins"
						<br>
						<br>
						<img src="./assets/Scala1.png" class="responsive-images" />
						<br>
						<br>
						En la ventana que se nos abre, buscaremos Scala y lo instalaremos (Será necesario reiniciar)
						<br>
						<br>
						<img src="./assets/Scala2.png" class="responsive-images" />
						<br>
						<br>
						Con el plugin instalado podremos crear nuevos proyectos con Scala como lenguaje.
						<br>
						<br>
						<img src="./assets/Scala3.png" class="responsive-images" />
						<br>
						<br>
					</p>
					<span class="paso">Paso 4: Instalación de dependencias</span>
					<p class="text-justify">
						Para la realización de los gráficos utilizaremos una librería denominada,
						<strong>tablesaw</strong>. En el caso de que el prototipo se vaya a ejecutar y no a codificar,
						no es necesario realiar este paso.
						<br>
						Esta librería debe ser instalada mediante un gestor de dependencias, en este caso utilizaremos
						Maven, ya que está soportado nativamente en IntelliJ.
						Comenzamos habilitando Maven en el proyecto, para ello en la vista de "Project" seleccionamos la
						opción "Add new framework" que nos aparecerá cuando hagamos click secundario en el nombre del
						proyecto.
						<br>
						<img src="./assets/Maven1.png" class="responsive-images" />
						<br>
						<br>
						Y buscamos en la lista por "Maven"
						<br>
						<br>
						<img src="./assets/Maven2.png" class="responsive-images" />
						<br>
						<br>
						Esto nos generará un fichero denomina "pom.xml" que nos permitirá gestionar las dependencias de
						nuestro proyecto.
						El cual debe tener un aspecto similar, una vez hayamos añadido la dependencia.
						<br>
						<br>
						<img src="./assets/Maven3.png" class="responsive-images" />
						<br>
						<br>
						El código de la dependencia se puede obtener con el siguiente botón, se debe pegar dentro de la
						parte de &lt;project&gt; -->
						<button class="to-copy" style="background-color: transparent; border: 0px;" data-clipboard-text="
								<dependencies> 
									<dependency> 
										<groupId>tech.tablesaw</groupId> 
										<artifactId>tablesaw-core</artifactId> 
										<version>0.38.0</version> 
									</dependency> 
									<dependency>
										<groupId>tech.tablesaw</groupId>
										<artifactId>tablesaw-jsplot</artifactId>
										<version>0.38.0</version>
								</dependency>
							</dependencies>">
							<kbd><kbd>ctrl</kbd> + <kbd>c</kbd></kbd>
						</button>
					<div class="toast" role="alert" aria-live="assertive" aria-atomic="true" data-delay=1000>
						<div class="toast-body" style="color:#333">
							Código copiado al portapapeles
						</div>
					</div>
					</p>
				</div>
				<div class="col-10">
					<h3>2.3 Catálogo de requisitos</h3>
					<table class="table table-light table-striped">
						<thead>
							<th scope="col">Requisito</th>
							<th scope="col">Descripción</th>
							<th scope="col">Tipo de requisito</th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<th>Req 1</td>
								<td>Descarga de CSV desde la web <a
										href="https://covid19.isciii.es/">covid19.isciii.es</a></td>
								<td>Básico</td>
							</tr>
							<tr>
								<th>Categoría 2</th>
								<td>Modificación de los datos del CSV para adaptar el formato</td>
								<td></td>
							</tr>
							<tr>
								<td>Req 2.1</td>
								<td>Conversión de las fechas desde String a LocalDate</td>
								<td>Básico</td>
							</tr>
							<tr>
								<td>Req 2.2</td>
								<td>Cálculo de variaciones diarias</td>
								<td>Básico</td>
							</tr>
							<tr>
								<th>Req 3</th>
								<td>Obtención de la fecha de últimas modificaciones para realizar las comprobaciones
								</td>
								<td>Básico</td>
							</tr>
							<tr>
								<th>Categoría 4</th>
								<td>Análisis estadísticos de los datos</td>
								<td></td>
							</tr>
							<tr>
								<td>Req 4.1</td>
								<td>Recuentos totales nacionales</td>
								<td>Básico</td>
							</tr>
							<tr>
								<td>Req 4.2</td>
								<td>Recuentos totales por comunidad</td>
								<td>Básico</td>
							</tr>
							<tr>
								<td>Req 4.3</td>
								<td>Media total nacional</td>
								<td>Básico</td>
							</tr>
							<tr>
								<td>Req 4.4</td>
								<td>Media total por comunidad</td>
								<td>Básico</td>
							</tr>
							<tr>
								<td>Req 4.5</td>
								<td>Máximo total nacional</td>
								<td>Básico</td>
							</tr>
							<tr>
								<td>Req 4.6</td>
								<td>Máximo total por comunidad</td>
								<td>Básico</td>
							</tr>
							<tr>
								<th>Categoría 5</th>
								<td>Comparación de los datos</td>
								<td></td>
							</tr>
							<tr>
								<td>Req 5.1</td>
								<td>Comparación de los datos entre comunidades</td>
								<td>Básico</td>
							</tr>
							<tr>
								<td>Req 5.2</td>
								<td>Comparación de los datos entre comunidad y total nacional</td>
								<td>Básico</td>
							</tr>
							<tr>
								<td>Req 5.3</td>
								<td>Comparación de los datos en función de fechas</td>
								<td>Básico</td>
							</tr>
							<tr>
								<th>Categoría 6</th>
								<td>Representación gráfica de los datos</td>
								<td></td>
							</tr>
							<tr>
								<td>Req 6.1</td>
								<td>Representación de gráfica de barras</td>
								<td>Deseado</td>
							</tr>
							<tr>
								<td>Req 6.2</td>
								<td>Representación de gráfica de líneas</td>
								<td>Deseado</td>
							</tr>
							<tr>
								<th>Req 7</th>
								<td>Solicitud via teclado de las diferentes opciones que se ofrecen</td>
								<td>Deseado</td>
							</tr>
						</tbody>
					</table>
				</div>
				<div class="col-10">
					<h3>2.4 Uso de dependencias</h3>
					<span class="paso">Tablesaw</span>
					<p class="text-justify">
						Tablesaw es una librería que permite gestionar y visualizar Dataframes, permite hacer más fácil
						la vida de quien quiere manipular datos y aplicar ciencia de datos a Java.
						<br>
						En su página web oficial podemos encontrar toda la <a
							href="https://jtablesaw.github.io/tablesaw/gettingstarted">documencación</a> necesaria para
						poder utilizarla.
						<br>
						Para los prototipos, será necesario utilizar los siguientes métodos:
					<ul>
						<li><a href="https://jtablesaw.github.io/tablesaw/userguide/importing_data">Importación de
								CSV</a></li>
						<ul>
							<li>Table.read().csv(InputStream stream, String tableName);</li>
						</ul>
						<li><a href="https://jtablesaw.github.io/tablesaw/userguide/columns">Manipulación de
								columnas</a></li>
						<ul>
							<li>table.column("Foo");</li>
						</ul>
						<li><a href="https://jtablesaw.github.io/tablesaw/userguide/rows">Manipulación de filas</a>
						</li>
						<ul>
							<li>for (Row row : table) {
								System.out.println("On " + row.getDate("date") + ": " + row.getDouble("approval"));
								}</li>
						</ul>
						<li><a href="https://jtablesaw.github.io/tablesaw/userguide/sorting">Ordenación de
								tablas</a></li>
						<ul>
							<li>sorted = table.sortAscendingOn("bar");</li>
						</ul>
						<li><a href="https://jtablesaw.github.io/tablesaw/userguide/reducing">Resumir datos de las
								tablas</a></li>
						<ul>
							<li>Table summary = table.summarize("sales", mean, sum, min, max).by("province",
								"status");</li>
						</ul>
						<li><a href="https://jtablesaw.github.io/tablesaw/userguide/TimeSeries">Creación de Series
								de tiempo</a></li>
						<ul>
							<li>Plot.show(TimeSeriesPlot.create("Fox approval ratings", foxOnly, "date",
								"approval"));</li>
						</ul>
					</ul>
					</p>
					<span class="paso">InputStream</span>
					<p class="text-justify">
						Es una librería nativa de Java que permite obtener datos byte a byte, incluso desde redes de
						internet
						<br>
						En su página web oficial podemos encontrar toda la <a
							href="https://docs.oracle.com/javase/8/docs/api/java/io/InputStream.html">documencación</a>
						necesaria para
						poder utilizarla.
						<br>
						Para los prototipos, será necesario utilizar los siguientes métodos:
					<ul>
						<li>Obtención mediante Stream de ficheros</li>
						<ul>
							<li>InputStream input = new URL("http://example.com/file.csv").openStream();</li>
						</ul>
					</ul>
					</p>
					<br>
					<br>
				</div>
				<div class="col-10">
					<h3>2.5 Explicación de requisitos</h3>
					<span class="paso">Requisito 1. Descarga de CSV</span>
					<p class="text-justify">
						El Instituto de Salud Carlos III proporciona la información de los casos registrados, entre otra
						información, en formato CSV que puede ser descargado de forma gratuita.
						Esta información es una recopilación de los datos que ofrece individualmente cada comunidad
						autónomas, por lo que se actualiza cuando estas publican nueva información.
						Este fichero CSV, se descarga en memoria durante la ejecución del programa, no se guarda ninguna
						información en disco.
					</p>
					<span class="paso">Categoría 2. Modificación del CSV y adaptación del formato</span>
					<br>
					<span class="subpaso">Requisito 2.1 Conversión de fecha</span>
					<p class="text-justify">
						Al empezar a utilizar el CSV descargado, nos encontraremos con determinadas cosas que se deben
						ser adaptadas para poder utilizarlas en el programa.
						Una de las primeras cosas que debemos adaptar son las fechas, ya que son reconocidas como String
						en lugar de LocalDate (el formato de variable que utiliza Java).
						Es necesario parsear el formato para poder utilizar funciones de ordenación.
					</p>
					<span class="subpaso">Requisito 2.2 Cálculo de variaciones diarias</span>
					<p class="text-justify">
						Debido a las operaciones que van a realizarse y a que el documento CSV ofrece datos acumulados,
						es necesario calcular las variaciones que han ocurriendo por fecha para poder trabajar de forma
						más correcta.
					</p>
					<span class="paso">Requisito 3. Obtención de la fecha de últimas modificaciones</span>
					<p class="text-justify">
						Dado que los datos que ofrecen las comunidades pueden no estar actualizados, es necesario
						comprobar la fecha de la última actualización para evitar que el usuario del prototipo escoja
						fechas fuera de rangos.
					</p>
					<span class="paso">Categoría 4. Análisis estadísticos de los datos</span>
					<br>
					<span class="paso">Requisito 4.1 Recuentos totales nacionales</span>
					<p class="text-justify">
						Es necesario obtener el recuento total para cada una de las categorías que ofrece el CSV.
					</p>
					<span class="paso">Requisito 4.2 Recuentos totales por comunidad</span>
					<p class="text-justify">
						Es necesario obtener el recuento total para cada una de las categorías que ofrece el CSV.
					</p>
					<span class="paso">Requisito 4.3 Media total nacional</span>
					<p class="text-justify">
						Es necesario obtener la media de cada categoría que ofrece el CSV.
						<br>
						Estos datos se calculan durante todo el periodo de fechas disponible y otro en un rango
						especificado.
					</p>
					<span class="paso">Requisito 4.4 Media total por comunidad</span>
					<p class="text-justify">
						Es necesario obtener la media de cada categoría que ofrece el CSV.
						<br>
						Estos datos se calculan durante todo el periodo de fechas disponible y otro en un rango
						especificado.
					</p>
					<span class="paso">Requisito 4.5 Máximo total nacional</span>
					<p class="text-justify">
						Es necesario obtener los valores máximos de cada variación para cada categoría que ofrece el
						CSV.
						<br>
						Estos valores pueden venir de diferentes comunidades y mostrarán el mayor resultado y su fecha.
					</p>
					<span class="paso">Requisito 4.6 Máximo total por comunidad</span>
					<p class="text-justify">
						Es necesario obtener los valores máximos de cada variación para cada categoría que ofrece el
						CSV.
						<br>
						Estos valores serán para diferentes fechas en función del campo que se trate.
					</p>
					<span class="paso">Categoría 5. Comparación de los datos</span>
					<br>
					<span class="paso">Requisito 5.1 Comparación de los datos entre comunidades</span>
					<p class="text-justify">
						Una de las funcionalidades debe ser mostrar para comparar los datos calculados entre comunidades
					</p>
					<span class="paso">Requisito 5.2 Comparación de los datos entre comunidad y total nacional</span>
					<p class="text-justify">
						Una de las funcionalidades debe ser mostrar para comparar los datos calculados entre comunidades
						comparando con los datos nacionales
					</p>
					<span class="paso">Requisito 5.3 Comparación de los datos en función de fechas</span>
					<p class="text-justify">
						El usuario puede poder elegir una fecha y se deberá poder mostrar los datos en función de esa
						fecha, tanto los datos calculados como las comparaciones.
					</p>
					<span class="paso">Categoría 6. Representación gráfica de los datos</span>
					<br>
					<span class="paso">Requisito 6.1 Representación de gráfica de barras</span>
					<p class="text-justify">
						Para poder visualizar los datos correctamente, se debe poder mostrar los datos calculados en
						forma de barra para poder comparar comunidades entre ellas o con los datos nacioanles totales.
						Esta gráfica debe poder estar especificada en determinadas fechas.
					</p>
					<span class="paso">Requisito 6.2 Representación de gráfica de líneas</span>
					<p class="text-justify">
						Para poder visualizar los datos correctamente, se debe poder mostrar la evolución de los
						diferentes datos que se ofrece para cada comunidad.
					</p>
					<span class="paso">Requisito 7. Solicitud via teclado de las diferentes opciones que se
						ofrecen</span>
					<p class="text-justify">
						El usuario debe ser capaz de elegir por teclado entre las diferentes opciones que el programa es
						capaz de realizar.
					</p>
				</div>


				<div class="col-10">
					<br>
					<br>
					<br>
					<br>
					<h3>Nota Explicación en la recogida de datos</h3>
					<p class="text-justify">
						Durante la elaboración del trabajo surgieron complicaciones y
						modificaciones en los datos que se recogían por lo que consideramos necesario dar una
						explicación a las diferentes acciones que se han realizado y porque
					</p>
					<br>
					<br>
					<span class="paso">Primer problema encontrado</span>
					<p class="text-justify">
						A partir del día 25 de Abril, el Instituto de Salud Carlos III (el origen de los datos) modifica
						la presentación del CSV, añadiendo nuevas columnas.
					</p>
					<br>
					<br>
					<span class="paso">Segundo problema encontrado</span>
					<p class="text-justify">
						A partir del día 26 de Abril, el Instituto de Salud Carlos III (el origen de los datos) modifica
						la presentación del CSV, añadiendo nuevas filas con notas al final del documento, estas filas no
						están bien formateadas así que no puede abrirse el documento por completo.
					</p>
					<p class="text-justify">
						En este caso se decide crear un script en python que se encargue de descargar periódicamente los
						datos desde el servidor del ISC III, modificar el formato del csv para eliminar las filas
						problemáticas.
						Una vez generado el CSV correctamente se sube a un servidor propio desde donde se permite la
						descarga para los dos prototipos.
					</p>
					<p class="text-justify">
						Esta solución sigue funcionando hasta el día 17 de Mayo, a pesar de que se siguen añadiendo
						nuevos más filas con datos mal formateados.
					</p>
					<br>
					<br>
					<span class="paso">Tercer problema encontrado</span>
					<p class="text-justify">
						A partir del día 17 de Mayo, tanto comunidades como Gobierno deciden modificar todos los
						criterios de valoración de los datos que se entregan, además de modificar las fechas en las que
						se entregan los datos a dominio público (Se cambia de entregar los datos de forma diaria a forma
						semanal).
						A parte de eso, el ISC III deja de actualizar los datos que ofrece y elimina los valores de los
						datos de Casos.
						Esta eliminación radica de que desde ese momento solo se aceptan como Casos los confirmados por
						PCR o TestAC+.
						Debido a ello, no se tiene una contabilización real de los datos que se pretendían mostrar.
					</p>
					<br>
					<br>
					<span class="paso">Solución definitiva</span>
					<p class="text-justify">
						Debido al último problema expuesto, la presentación de los datos siempre sería incorrecta, más
						incluso de que los datos siempres serían antiguos.
						Tras investigar se encuentra el <a
							href="https://github.com/datadista/datasets/tree/master/COVID%2019" target="_blank">siguente
							repositorio
						</a> que se encarga de recopilar los datos.
						Estos datos son justo los que necesitamos, pero al llevar ya avanzados los prototipos adeacuados
						al formato en que se recogían los datos del ISC III, se decide crear otro script de python que
						se encarga de descargar manualmente todos los ficheros CSV, adaptar su formato y ofrecerlo en
						esta <a href="http://daniel.halogenos.org/agregados.csv" target="_blank">URL</a>
					</p>
					<p class="text-justify">
						El código del script de python puede verse en la siguiente <a
							href="./assets/python/create_csv.py" target="_blank">página</a>
					</p>
				</div>
			</div>



		</div>


		<span class="index-number" id="3"></span>
		<div class="content not-even-content">
			<div class="row justify-content-center">
				<div class="col-10">
					<h2 class="title-section">3. Criterios de comparacion de los prototipos</h2>
					<br>
				</div>
				<div class="col-10">
					<h3>3.1 Criterio 1</h3>
					<ul>
						<li>Nombre del criterio: Horas de desarrollo de prototipo</li>
						<li>Descripcion: Horas utilizadas para el desarrollo del prototipo</li>
						<li>Tipo de valor: Numérico (horas).</li>
					</ul>
				</div>
				<div class="col-10">
					<h3>3.2 Criterio 2</h3>
					<ul>
						<li>Nombre del criterio: Tiempo de compilación</li>
						<li>Descripcion: Milisegundos utilizados para la compilación del binario del programa</li>
						<li>Tipo de valor: Numérico (Milisegundos).</li>
					</ul>
				</div>
				<div class="col-10">
					<h3>3.3 Criterio 3</h3>
					<ul>
						<li>Nombre del criterio: Tiempo de cálculo de los análisis estadísticos</li>
						<li>Descripcion: Milisegundos utilizados para el cálculo de los datos estadísticos
						</li>
						<li>Tipo de valor: Numérico (Milisegundos).</li>
					</ul>
				</div>
				<div class="col-10">
					<h3>3.4 Criterio 4</h3>
					<ul>
						<li>Nombre del criterio: Tiempo de cálculo de datos diarios</li>
						<li>Descripcion: Milisegundos utilizados para el cálculo de los datos diarios</li>
						<li>Tipo de valor: Numérico (Milisegundos).</li>
					</ul>
				</div>
				<div class="col-10">
					<h3>3.5 Criterio 5</h3>
					<ul>
						<li>Nombre del criterio: Tamaño de los archivos compilados</li>
						<li>Descripcion: Tamaños en Kilobytes de los ficheros compilados</li>
						<li>Tipo de valor: Numérico (Kilobytes).</li>
					</ul>
				</div>
				<div class="col-10">
					<h3>3.6 Criterio 6</h3>
					<ul>
						<li>Nombre del criterio: Memoria utilizada durante los cálculos estadíticos</li>
						<li>Descripcion: Durante la ejecución del programa y realización de los cálculos, es interesante
							comprobar la memoria RAM que se utiliza para prototipo</li>
						<li>Tipo de valor: Numérico (Kilobytes).</li>
					</ul>
				</div>
				<div class="col-10">
					<h3>3.7 Criterio 7</h3>
					<ul>
						<li>Nombre del criterio: Memoria utilizada durante los cálculos diarios</li>
						<li>Descripcion: Durante la ejecución del programa y realización de los cálculos, es interesante
							comprobar la memoria RAM que se utiliza para prototipo</li>
						<li>Tipo de valor: Numérico (Kilobytes).</li>
					</ul>
				</div>
				<div class="col-10">
					<h3>3.8 Criterio 8</h3>
					<ul>
						<li>Nombre del criterio: Memoria utilizada durante los ejecución compleja del programa
						</li>
						<li>Descripcion: Durante la ejecución del programa, realizar en el mismo equipo los mismos
							conjunto de operaciones de gráficas, comparaciones y cálculos, para obtener la
							memoria RAM utilizada</li>
						<li>Tipo de valor: Numérico (Kilobytes).</li>
					</ul>
				</div>
				<div class="col-10">
					<h3>3.8 Criterio 9</h3>
					<ul>
						<li>Nombre del criterio: Líneas de código
						</li>
						<li>Descripcion: Líneas de código utilzidas para crear el prototipo</li>
						<li>Tipo de valor: Numérico (Líneas).</li>
					</ul>
				</div>
				<div class="col-10">
					<h3>3.8 Criterio 10</h3>
					<ul>
						<li>Nombre del criterio: Número de archivos compilados generados
						</li>
						<li>Descripcion: Cada lenguaje puede crear diferentes ficheros que pueden ser necesarios durante su compilación</li>
						<li>Tipo de valor: Numérico (Archivos).</li>
					</ul>
				</div>
				<div class="col-10">
					<h3>3.8 Criterio 11</h3>
					<ul>
						<li>Nombre del criterio: Tiempo de segunda compilación
						</li>
						<li>Descripcion: Tras la primera compilación, las siguientes que se producirán son incrementales</li>
						<li>Tipo de valor: Numérico (Milisegundos).</li>
					</ul>
				</div>
			</div>
		</div>


		<span class="index-number" id="4"></span>
		<div class="content even-content">
			<div class="row justify-content-center">
				<div class="col-10">
					<h2 class="title-section">4. Implementación del prototipo con tecnología A</h2>

					<p class="text-justify">Toda la documentación del prototipo A se encuentra en:
						<a
							href="https://gitlab.com/dte2020/m5/tg3/-/tree/master/prototipo-A/">https://gitlab.com/dte2020/m5/tg3/-/tree/master/prototipo-A/</a>.
					</p>
					<p class="text-justify">En la realización del prototipo-A se ha ido modificando la documentación de
						dicha carpeta, en la cual se encuentra la carpeta de archivos Proyecto-A completado por los
						archivos del programa para el prototipo A. Estos archivos son los siguientes:</p>
					<h3>4.1. Proyecto A.iml</h3>
					<p class="text-justify">
						Este archivo de módulos creado por IntelliJ almacena la información relacionada con el módulo de
						desarrollo particular y guarda las diversas configuraciones y los datos del programa. Por
						ejemplo, se puede observar que ha guardado las librerías implementadas en el programa y los
						módulos.


					</p>
					<h3>4.2. pom.xml</h3>

					<p class="text-justify">
						Este documento XML es un conjunto de códigos que se aplican en el análisis de datos y
						proporciona una plataforma para definir elementos para crear un formato y generar un lenguaje
						personalizado. Este fichero hereda una serie de propiedades del fichero super pom en el que
						viene indicado las propiedades estándar que usa Maven.


					</p>
					<h3>4.3 Carpeta .idea</h3>
					<p class="text-justify"> 4.3 Carpeta .idea
						Esta carpeta es creada por la aplicación Intellij IDE y es donde se guarda todos los ajustes
						específicos del proyecto, como por ejemplo las librerías de Maven utilizadas o los módulos


					</p>
					<h3>4.4 Carpeta lib</h3>
					<p class="text-justify">
						En esta carpeta se guardan las librerías de Kotlin utilizadas en el proyecto.


					</p>
					<h3>4.5 Carpeta target</h3>
					<p class="text-justify">
						Dentro de esta carpeta se crean otras nuevas al compilar el proyecto. Dentro de esta se forma la
						carpeta clases que genera las clases compiladas (MainKt.class, Comunity.class) y el módulo del
						proyecto.

					</p>
					<h3>4.6 Carpeta src</h3>
					<p class="text-justify">
						Es el conjunto de carpetas del proyecto donde se almacena el código fuente. Dentro podemos
						encontrar 3 archivos .kt: Communities, DataTable y la clase main.
					<h3> 4.6.1. main.kt </h3>
					<p>Es la clase principal del programa que mostrará por pantalla los datos deseados al usuario. Está
						compuesto por:</p>
					<p>
						<li><i>import kotlin.system.exitProcess</i>: termina el proceso en ejecución.</li>
					</p>
					<p>
						<li><i>fun main()</i>: nos permite acceder a la función main. En este comando pedimos que enseñe
							por pantalla los datos de la tabla de datos.</li>
					</p>
					<p>
						<li><i>fun whatGraphics()</i>: nos permite acceder a la función de elección de las estadísticas
							de las gráficas.</li>
					</p>
					<p>
						<li><i>fun askForGraphics()</i>: nos permite acceder a la función de elección de datos numéricos
							y la obtención de gráficas a partir de datos. </li>
					</p>
					<h3> 4.6.2. Communities.kt</h3>
					<p> La clase de Communities es utilizada para la selección de las Comunidades Autónomas que el
						usuario desea observar. Los atributos dentro de esta clase son:</p>
					<p>
						<li><i>private val communities</i> : objeto de la clase que son todas las Comunidades Autónomas
							de España.</li>
					</p>
					<p>
						<li><i>private var selectedCommunities</i>: ArrayList de la clase en la que se meterán las
							comunidades seleccionadas. </li>
					</p>
					<p>
						<li><i>private var tempCommunities = this.communities.toMutableList()</i> : lista mutable en la
							que se puede remover o cambiar la selección de las comunidades.</li>
					</p>
					<p> Dentro de la clase tenemos los siguientes métodos:</p>
					<p>
						<li><i>fun selectCommunities(): MutableList </i> | Método que escoge dentro de la lista de
							Comunidades Autónomas las seleccionadas por el usuario. </li>
					</p>
					<p>
						<li><i>private fun addToSelectedList(selection: Int)</i> | Método que añade una o más
							selecciones a la lista.</li>
					</p>
					<p>
						<li><i>private fun generatePrint(): String {</i> | Método que genera la lista final con la cual
							se ejecutarán los datos de las Comunidades seleccionadas.</li>
					</p>
					<h3> 4.6.3. DataTable.kt</h3>
					<p> La clase DataTable es utilizada para la recopilación de datos del csv proporcionada por la
						página web del Instituto de Salud Carlos III. Los atributos dento de esta clase son:</p>
					<p>
						<li><i>private var table: Table</i> : Objeto de la clase que es la tabla con los datos
							seleccionados. </li>
					</p>
					<p>
						<li><i>private var initialTable: Table</i> : Objeto de la clase que es la tabla original de
							datos. </li>
					</p>
					<p>
						<li><i>private val communities = Communities()</i> : Objeto de la clase Communities que son las
							Comunidades Autónomas del país. </li>
					</p>
					<p>
						<li><i>val finalTable =
								this.table.where(this.table.dateColumn("FECHA").isBetweenIncluding(initialDate,
								finalDate))</i> : Objeto de la clase que es la tabla final de datos.</li>
					</p>
					<p>
						<li><i>val community = askForWhat()</i> : Objeto que es la comunidad seleccionada. </li>
					</p>
					<p>
						<li><i>val whatToCalculate = askWhatToShow()</i> : Objeto de la clase que es lo que se quiere
							calcular.</li>
					</p>
					<p>
						<li><i>val arrayDates = getDates(askDate().toInt())</i> : Objeto de la clase que son las fechas.
						</li>
					</p>
					<p>
						<li><i>val arrayDates = getDates(askDate().toInt())</i> : Objeto de la clase que son las fechas.
						</li>
					</p>
					<p>
						<li><i>val selectedCommunities = this.communities.selectCommunities()</i> : Objeto que son las
							comunidades seleccionadas.</li>
					</p>
					<p>
						<li><i>val initialDate: LocalDate</i> : Objeto que es la fecha inicial seleccionada.</li>
					</p>
					<p>
						<li><i>val finalDate: LocalDate</i> : Objeto que es la fecha final seleccionada.</li>
					</p>
					<p>
						<li><i>val dataToShow = askForWhat()</i> : Objeto que es la información final que se debe
							mostrar</li>
					</p>
					<p>
						<li><i>val field = askForElement()</i> : Objeto que es el campo seleccionado.</li>
					</p>
					<p>
						<li><i>val textTitle: String </i>: Objeto que es el título que se da a los datos de la media, el
							máximo y el total.</li>
					</p>
					<p>
						<li><i>val column: String</i> : Objeto que es el nombre de las columnas.</li>
					</p>
					<p>Dentro de la clase tenemos los siguientes métodos:</p>
					<p>
						<li><i>fun createTable()</i> | Método que genera una tabla editable nueva. </li>
					</p>
					<p>
						<li><i>private fun getCSV(): Table</i> | Método que recoge la tabla de datos csv del Instituto
							de Salud Carlos III. </li>
					</p>
					<p>
						<li><i>private fun editTable(t: Table): Table</i> | Método que edita la tabla dividiéndola en
							los diferentes datos clasificatorios, los cuales son: CCAA, FECHA, CASOS, CASOS ACUMULADOS,
							ALTAS, ALTAS ACUMULADAS, PCR+, PCR+ ACUMULADO, TESTAC+, TESTAC+ ACUMULADO, HOSPITALIZADOS,
							HOSPITALIZADOS ACUMULADOS, UCI, UCI ACUMULADO, FALLECIDOS, FALLECIDOS ACUMULADOS.</li>
					</p>
					<p>
						<li><i>private fun addingData(r: Row, t: Table?): Table?</i> | Método que añade los datos de la
							tabla original a la tabla del programa.</li>
					</p>
					<p>
						<li><i>private fun calculateDailyData(t: Table?): Table?</i> | Método que calcula los datos
							diarios de cada fecha.</li>
					</p>
					<p>
						<li><i>private fun generateCountryTable(initialDate: LocalDate, finalDate: LocalDate,
								whatToCalculate: Int): Table?</i> | Método que genera la tabla de datos dependiendo de
							las fechas. Se obtiene el total, el máximo y la media de casos del país.</li>
					</p>
					<p>
						<li><i>private fun generateCommunityTable(communityList: List&lt;String&gt;, initialDate:
								LocalDate,
								finalDate: LocalDate, whatToCalculate: Int): Table?</i> | Método de la clase que
							genera la tabla por comunidades seleccionadas. Muestra los totales entre comunidades, los
							máximos entre comunidades y la media entre comunidades.</li>
					</p>
					<p>
						<li><i>private fun compareAndGetBigger(t1: Table?, t2: Table?): Table?</i> | Método que compara
							por columna los datos de las tablas.</li>
					</p>
					<p>
						<li><i>private fun summarizingData(t: Table): Table? </i>| Método que “resume” los datos de las
							columnas CASOS, ALTAS, PCR+, HOSPITALIZADOS, UCI y FALLECIDOS. </li>
					</p>
					<p>
						<li><i>private fun averageData(t: Table): Table?</i> | Método que recoge los datos de las
							columnas CASOS, ALTAS, PCR+, HOSPITALIZADOS, UCI y FALLECIDOS para realizar una media de
							estos.</li>
					</p>
					<p>
						<li><i>private fun generateMaxCountry(t: Table): Table?</i> | Método que crea una tabla
							denominada Máximos Nacionales, dividida en las columnas: FECHA, CAMPO, MÁXIMO. Esta tabla
							muestra al usuario los datos máximos de casos en el país.</li>
					</p>
					<p>
						<li><i>private fun generateMaxCommunity(t: Table): Table?</i> | Método que realiza la misma
							función que el anterior método, pero en este caso es por comunidad. Esta nueva tabla se
							muestra con el nombre Máximos ente comunidades.</li>
					</p>
					<p>
						<li><i>private fun askWhatToShow(): Int</i> | Método de la clase que interacciona con el usuario
							pidiendo los datos que el usuario desea ver.</li>
					</p>
					<p>
						<li><i>private fun checkDateIsCorrect(dateToCheck: LocalDate, firstDate: LocalDate?):
								Boolean</i> | Método que comprueba si la fecha de los datos es la correcta.</li>
					</p>
					<p>
						<li><i>private fun selectDate(needsTwoDates: Boolean, isSecondDate: Boolean, firstDate:
								LocalDate?): LocalDate</i> | Método que interacciona con el usuario pidiéndole una fecha
							que desee seleccionar.</li>
					</p>
					<p>
						<li><i>private fun askDate(): String</i> | Método que interactúa con el usuario en relación
							sobre la selección de una fecha concreta o un periodo de tiempo para la consulta de datos.
						</li>
					</p>
					<p>
						<li><i>fun getWhatToCalculate(isGraphics: Boolean)</i> | Método que calcula mediante las tablas
							las funciones anteriormente mencionadas.</li>
					</p>
					<p>
						<li><i>private fun getDates(whatType: Int): Array&lt;LocalDate&gt;</i> | Método que recoge las
							fechas
							entre la fecha inicial y final seleccionadas.</li>
					</p>
					<p>
						<li><i>fun getWhereToShowGraphics()</i> | Método que elige la información seleccionada, las
							fechas seleccionadas y el campo.</li>
					</p>
					<p>
						<li><i>private fun askForWhat(): Int</i> | Método que interactúa con el usuario para que
							seleccione los datos que desea ver. Las opciones son: Nacionales, Comunidades, Nacionales vs
							Comunidades.</li>
					</p>
					<p>
						<li><i>private fun drawBarPlot(t: Table, whatToShow: Int, field: String)</i> | Método que
							muestra una tabla con la media, el máximo y el total de los datos seleccionados.</li>
					</p>
					<p>
						<li><i>private fun askForElement(): String</i> | Método que interactúa con el usuario
							preguntándole que elemento quiere dibujar en gráfica.</li>
					</p>
					<p>
						<li><i>private fun getTableForGraphic(typeData: Int, initialDate: LocalDate, finalDate:
								LocalDate): Table?</i> | Método que genera gráficas a partir de las tablas.</li>
					</p>
					<p>
						<li><i>private fun timeSerieGraphic(t: Table?, field: String)</i> | Método que genera gráficas a
							partir de las columnas de Casos, Altas, PCR+, TestAc+, Hospitalizados, UCI, Fallecidos.</li>
					</p>
					<p>
						<li><i>private fun generateCommunityTimeSerieGraphic(communityList: List&lt;String&gt;,
								initialDate:
								LocalDate, finalDate: LocalDate): Table? </i>| Método que genera gráficas a partir
							de la tabla de comunidades.</li>
					</p>
					<p>
						<li><i>private fun generateCountryTimeSerieGraphic(initialDate: LocalDate, finalDate:
								LocalDate): Table?</i> | Método que genera gráficas a partir de la tabla de comunidades.
						</li>
					</p>

					<p class="text-justify">
					<h3>4.6 Carpeta src</h3>

					Es el conjunto de carpetas del proyecto donde se almacena el código fuente. Dentro podemos
					encontrar 3 archivos .kt: Communities, DataTable y la clase main.
					<ul>
						<li>
							<p class="text-justify">
							<h4>4.6.1. main.kt</h4>
							Es la clase principal del programa que mostrará por pantalla los datos
							deseados al usuario. Está compuesto por:
							<ul>
								<li>
									import kotlin.system.exitProcess: termina el proceso en ejecución.
								</li>
								<li>
									fun main(): nos permite acceder a la función main. En este comando pedimos que
									enseñe por
									pantalla los datos de la tabla de datos.
								</li>
								<li>
									fun whatGraphics(): nos permite acceder a la función de elección de las estadísticas
									de las
									gráficas.
								</li>
								<li>
									fun askForGraphics(): nos permite acceder a la función de elección de datos
									numéricos y la
									obtención de gráficas a partir de datos.
								</li>
							</ul>
							</p>
						</li>
						<li>
							<p class="text-justify">
							<h4>4.6.2. Communities.kt</h4>
							La clase de Communities es utilizada para la selección de las
							Comunidades Autónomas que el usuario desea observar. Los atributos dentro de esta clase son:
							<ul>
								<li>
									private val communities: objeto de la clase que son todas las Comunidades Autónomas
									de España.
								</li>
								<li>
									private var selectedCommunities: ArrayList de la clase en la que se meterán las
									comunidades
									seleccionadas.
								</li>
								<li>
									private var tempCommunities = this.communities.toMutableList() : lista mutable en la
									que se
									puede remover o cambiar la selección de las comunidades.
								</li>
							</ul>
							Dentro de la clase tenemos los siguientes métodos:
							<ul>
								<li>
									fun selectCommunities(): MutableList&lt;String&gt;: Método que escoge dentro de la
									lista
									de
									Comunidades Autónomas las seleccionadas por el usuario.
								</li>
								<li>
									private fun addToSelectedList(selection: Int) : Método que añade una o más
									selecciones a
									la lista.
								</li>
								<li>
									private fun generatePrint(): String { : Método que genera la lista final con la cual
									se
									ejecutarán los datos de las Comunidades seleccionadas.
								</li>
							</ul>
							</p>
						</li>
						<li>
							<p class="text-justify">
							<h4>4.6.3. DataTable.kt</h4>
							La clase DataTable es utilizada para la recopilación de datos del csv
							proporcionada por la página web del Instituto de Salud Carlos III. Los atributos dento de
							esta clase son
							<ul>
								<li>
									private var table: Table : Objeto de la clase que es la tabla con los datos
									seleccionados
								</li>
								<li>
									private var initialTable: Table : Objeto de la clase que es la tabla original de
									datos.
								</li>
								<li>
									private val communities = Communities() : Objeto de la clase Communities que son las
									Comunidades Autónomas del país.
								</li>
								<li>
									val finalTable =
									this.table.where(this.table.dateColumn("FECHA").isBetweenIncluding(initialDate,
									finalDate))
									: Objeto de la clase que es la tabla final de datos.
								</li>
								<li>
									val community = askForWhat() : Objeto que es la comunidad seleccionada
								</li>
								<li>
									val whatToCalculate = askWhatToShow() : Objeto de la clase que es lo que se quiere
									calcular.
								</li>
								<li>
									val arrayDates = getDates(askDate().toInt()) : Objeto de la clase que son las
									fechas.
								</li>
								<li>
									val selectedCommunities = this.communities.selectCommunities() : Objeto que son las
									comunidades seleccionadas.
								</li>
								<li>
									val initialDate: LocalDate : Objeto que es la fecha inicial seleccionada.
								</li>
								<li>
									val finalDate: LocalDate : Objeto que es la fecha final seleccionada.
								</li>
								<li>
									val dataToShow = askForWhat() : Objeto que es la información final que se debe
									mostrar
								</li>
								<li>
									val field = askForElement() : Objeto que es el campo seleccionado.
								</li>
								<li>
									val textTitle: String : Objeto que es el título que se da a los datos de la media,
									el
									máximo y el total.
								</li>
								<li>
									val column: String : Objeto que es el nombre de las columnas.
								</li>
							</ul>
							Dentro de la clase tenemos los siguientes métodos:
							<ul>
								<li>
									fun createTable() : Método que genera una tabla editable nueva
								</li>
								<li>
									private fun getCSV(): Table : Método que recoge la tabla de datos csv del Instituto
									de
									Salud Carlos III
								</li>
								<li>
									private fun editTable(t: Table): Table : Método que edita la tabla dividiéndola en
									los
									diferentes datos clasificatorios, los cuales son: CCAA, FECHA, CASOS, CASOS
									ACUMULADOS,
									ALTAS, ALTAS ACUMULADAS, PCR+, PCR+ ACUMULADO, TESTAC+, TESTAC+ ACUMULADO,
									HOSPITALIZADOS,
									HOSPITALIZADOS ACUMULADOS, UCI, UCI ACUMULADO, FALLECIDOS, FALLECIDOS ACUMULADOS.
								</li>
								<li>
									private fun addingData(r: Row, t: Table?): Table? : Método que añade los datos de la
									tabla
									original a la tabla del programa.
								</li>
								<li>
									private fun calculateDailyData(t: Table?): Table? : Método que calcula los datos
									diarios
									de cada fecha.
								</li>
								<li>
									private fun generateCountryTable(initialDate: LocalDate, finalDate: LocalDate,
									whatToCalculate: Int): Table? : Método que genera la tabla de datos dependiendo de
									las
									fechas. Se obtiene el total, el máximo y la media de casos del país.
								</li>
								<li>
									private fun generateCommunityTable(communityList: List&lt;String&gt;, initialDate:
									LocalDate,
									finalDate: LocalDate, whatToCalculate: Int): Table? = Método de la clase que
									genera la
									tabla por comunidades seleccionadas. Muestra los totales entre comunidades, los
									máximos
									entre comunidades y la media entre comunidades.
								</li>
								<li>
									private fun compareAndGetBigger(t1: Table?, t2: Table?): Table? : Método que compara
									por columna los datos de las tablas.
								</li>
								<li>
									private fun summarizingData(t: Table): Table? : Método que “resume” los datos de las
									columnas CASOS, ALTAS, PCR+, HOSPITALIZADOS, UCI y FALLECIDOS.
								</li>
								<li>
									private fun averageData(t: Table): Table? : Método que recoge los datos de las
									columnas CASOS, ALTAS, PCR+, HOSPITALIZADOS, UCI y FALLECIDOS para realizar una
									media de
									estos.
								</li>
								<li>
									private fun generateMaxCountry(t: Table): Table? : Método que crea una tabla
									denominada Máximos Nacionales, dividida en las columnas: FECHA, CAMPO, MÁXIMO. Esta
									tabla muestra al usuario los datos máximos de casos en el país.
								</li>
								<li>
									private fun generateMaxCommunity(t: Table): Table? :Método que realiza la misma
									función que el anterior método, pero en este caso es por comunidad. Esta nueva tabla
									se muestra con el nombre Máximos ente comunidades.
								</li>
								<li>
									private fun askWhatToShow(): Int : Método de la clase que interacciona con el
									usuario pidiendo los datos que el usuario desea ver.
								</li>
								<li>
									private fun checkDateIsCorrect(dateToCheck: LocalDate, firstDate: LocalDate?):
									Boolean: Método que comprueba si la fecha de los datos es la correcta.
								</li>
								<li>
									private fun selectDate(needsTwoDates: Boolean, isSecondDate: Boolean, firstDate:
									LocalDate?): LocalDate : Método que interacciona con el usuario pidiéndole una fecha
									que desee seleccionar.
								</li>
								<li>
									private fun askDate(): String : Método que interactúa con el usuario en relación
									sobre
									la selección de una fecha concreta o un periodo de tiempo para la consulta de datos.
								</li>
								<li>
									fun getWhatToCalculate(isGraphics: Boolean) : Método que calcula mediante las tablas
									las funciones anteriormente mencionadas.
								</li>
								<li>
									private fun getDates(whatType: Int): Array&lt;LocalDate&gt; : Método que recoge las
									fechas
									entre la fecha inicial y final seleccionadas.
								</li>
								<li>
									fun getWhereToShowGraphics() : Método que elige la información seleccionada, las
									fechas seleccionadas y el campo.
								</li>
								<li>
									private fun askForWhat(): Int : Método que interactúa con el usuario para que
									seleccione los datos que desea ver. Las opciones son: Nacionales, Comunidades,
									Nacionales vs Comunidades.
								</li>
								<li>
									private fun drawBarPlot(t: Table, whatToShow: Int, field: String) : Método que
									muestra una tabla con la media, el máximo y el total de los datos seleccionados.
								</li>
								<li>
									private fun askForElement(): String : Método que interactúa con el usuario
									preguntándole que elemento quiere dibujar en gráfica.
								</li>
								<li>
									private fun getTableForGraphic(typeData: Int, initialDate: LocalDate, finalDate:
									LocalDate): Table? : Método que genera gráficas a partir de las tablas.
								</li>
								<li>
									private fun timeSerieGraphic(t: Table?, field: String) : Método que genera
									gráficas a partir de las columnas de Casos, Altas, PCR+, TestAc+, Hospitalizados,
									UCI, Fallecidos.
								</li>
								<li>
									private fun generateCommunityTimeSerieGraphic(communityList: List&lt;String&gt;,
									initialDate: LocalDate, finalDate: LocalDate): Table? : Método que genera
									gráficas a partir de la tabla de comunidades.
								</li>
								<li>
									private fun generateCountryTimeSerieGraphic(initialDate: LocalDate, finalDate:
									LocalDate): Table? : Método que genera gráficas a partir de la tabla de
									comunidades.
								</li>
							</ul>
							</p>
						</li>
					</ul>
				</div>
			</div>
		</div>

		<span class="index-number" id="5"></span>
		<div class="content not-even-content">
			<div class="row justify-content-center">
				<div class="col-10">
					<h2 class="title-section">5. Implementación del prototipo con tecnología B</h2>
					<p class="text-justify">
						Toda la documentación del prototipo B se encuentra en:
						<a
							href="https://gitlab.com/dte2020/m5/tg3/-/tree/master/prototipo-B/">https://gitlab.com/dte2020/m5/tg3/-/tree/master/prototipo-B/</a>.
					</p>
					<p class="text-justify">
						En la realización del prototipo B se ha ido modificando la documentación de dicha carpeta, la
						cual tiene otras subcarpetas que contienen todas las clases e información necesaria del Proyecto
						B. La ruta para encontrar las clases dentro del proyecto es la siguiente:
						<i>src/main/scala/Analisis_COVID_19</i>

					</p>

					<p class="text-justify">Antes de comentar el contenido del proyecto, hay que decir que los 5
						primeros archivos que tiene el Proyecto A son comunes también para el B y cumplen la misma
						funcionalidad.

					</p>

					<p class="text-justify">También decir que se ha trabajado con los <i>Object</i> de Scala, las cuales
						son instancias individuales de una clase que se denominan objetos singleton.
						Esto quiere decir que son una especie de mezcla entre la definición de una clase de utilización
						única,
						la cual no puede ser instanciada directamente, y un miembro val (constante).</p>

					<p class="text-justify">Básicamente esta forma de trabajar es similar al uso de <i>static</i> en
						Java. Es más, cuando se compilan los archivos declarados como <i>Object</i> y no como
						<i>Class</i>, se generan dos archivos compilados y esto se debe a
						que Scala traduce estos “objetos” a <i>Constructs</i> de JVM.</p>


					<p class="text-justify">La razón por la que hace esto es porque si se trabaja con librerías de Scala
						en proyectos Java, los proyectos Java no detectan estos <i>Object</i> particulares de Scala, por
						lo tanto, este archivo que se crea aparte del <i>.class</i> sirve como “interfaz” entre
						el <i>Object</i> y los elementos de Java, para tratarlos como si fuesen clases estáticas de
						Java.</p>

					<p class="text-justify"><b>Nota</b>: Todo aquel método que devuelva <i>Unit</i>, es equivalente a
						que devuelva <i>void</i>, es decir, no devuelve nada.</p>

					<h3>5.1 COMMUNITIES.scala</h3>

					<p class="text-justify">
						En este <i>Object</i> se definen todas las comunidades autónomas que el usuario va a elegir y
						los métodos para la elección de dichas comunidades para realizar las distintas acciones.
					<p>Los variables globales (de carácter privado) y constantes definidas son :</p>
					<p>
						<li><i>communities</i>: Objeto de la clase que son todas las Comunidades Autónomas de España.
						</li>
					</p>
					<p>
						<li><i>selectedCommunities</i>: Lista en la que se meterán las comunidades seleccionadas.</li>
					</p>
					<p>
						<li><i>tempCommunities</i>: Lista en la que se encuentran aquellas comunidades autónomas que no
							ha escogido el usuario.</li>
					</p>

					<p>Los métodos definidos son:</p>
					<p>
						<li><i>selectCommunities: -> ArrayBuffer[String]</i> | Función que se encarga de que el usuario
							escoja las comunidades autónomas, las cuales almacenará en un array una vez elegidas.</li>
					</p>
					<p>
						<li><i>isNumeric: String -> Boolean</i> | Comprobación para saber si un dato introducido es un
							número.</li>
					</p>
					<p>
						<li><i>print_autonomous_communities</i> | Imprime las comunidades autónomas elegidas por el
							usuario.</li>
					</p>
					<p>
						<li><i>addToSelectedList: Int</i> | Añade las comunidades que el usuario elija siempre que
							provengan del array tempCommunities.</li>
					</p>
					<p>
						<li><i>clearLists</i> | Borra el array de las comunidades seleccionadas por el usuario para que
							vuelva a realizar otra comparación con otras comunidades autónomas.</li>
					</p>

					</p>

					<h3>5.2 USER_GRAPHICS.scala</h3>
					<p class="text-justify">
						En este <i>Object</i> se definen los métodos disponibles que sirven para las elecciones sobre
						las gráficas del usuario. Se compone de dos métodos:
					<p>
						<li><i>whatGraphics: -> String</i> | Objeto de la clase que son todas las Comunidades Autónomas
							de España.</li>
					</p>
					<p>
						<li><i>askForGraphics: -> String</i> | Lista en la que se meterán las comunidades seleccionadas.
						</li>
					</p>
					</p>

					<h3>5.3 CSV_COVID_FILE.scala</h3>
					<p class="text-justify">
						En este <i>Object</i> es utilizado para la recopilación, análisis, manipulación y tratamiento de
						los datos del CSV que son proporcionados por la página web del Instituto de Salud Carlos III.
						Las variables
						globales (de carácter privado) y constantes que tiene este <i>Object</i> son:
					<p>
						<li><i>location</i>: Es el enlace donde se puede descargar el CSV con los datos correspondientes
							al COVID_19.</li>
					</p>
					<p>
						<li><i>covid_table</i>:Es una tabla que se genera a partir de la lectura del CSV.</li>
					</p>
					<p>
						<li><i>table_with_variations</i>:Es la tabla con la modificación de que se añaden las
							variaciones producidas de un día para otro de todos los campos, para tener los datos
							diarios.</li>
					</p>
					<p>
						<li><i>communities</i>:Esta variable hace referencia a la clase COMMUNITIES (NO es una
							instancia).</li>
					</p>

					<p>Los métodos definidos son:</p>
					<p>
						<li><i>load_csv_without_variations -> Table</i> | Muestra la tabla sin variaciones.</li>
					</p>
					<p>
						<li><i>load_csv_with_variations -> Table</i> | Muestra la tabla con variaciones.</li>
					</p>
					<p>
						<li><i>create_column: Array[Number], LocalDate, Int, String -> DoubleColumn</i> | Método que se
							encarga de crear las columnas.</li>
					</p>
					<p>
						<li><i>last_update_date-> LocalDate</i> | Obtiene la última fecha vigente en el CSV.</li>
					</p>
					<p>
						<li><i>generate_national_table: LocalDate, LocalDate, Int -> Table</i> | Genera la tabla
							nacional de máximos, medias o totales entre una fecha y otra.</li>
					</p>
					<p>
						<li><i>summarizingData: Table -> Table</i> | Se encarga de hacer la suma total de las
							variaciones nacionales.</li>
					</p>
					<p>
						<li><i>generateMaxCountry: Table -> Table</i> | Se encarga de hacer la tabla con los máximos
							nacionales.</li>
					</p>
					<p>
						<li><i>averageData: Table -> Table</i> | Se encarga de calcular la media de las variaciones
							nacionales.</li>
					</p>
					<p>
						<li><i>generateMaxCommunity: Table -> Table</i> | Crea la tabla con los máximos de una
							comunidad.</li>
					</p>
					<p>
						<li><i>generateCommunityTable: ArrayBuffer[String], LocalDate, LocalDate, Int -> Table</i> |
							Método de la clase que genera la tabla por comunidades seleccionadas. Muestra los totales
							entre comunidades, los máximos entre comunidades y la media entre comunidades en una fecha
							dada.</li>
					</p>
					<p>
						<li><i>compareAndGetBigger: Table, Table -> Table</i> | Método que compara los máximos de de
							cada campo de cada tabla y devuelve la mayor.</li>
					</p>
					<p>
						<li><i>askWhatToShow: -> Int</i> | Permite al usuario elegir los datos que quiere ver (Media,
							totales o máximos).</li>
					</p>
					<p>
						<li><i>checkDateIsCorrect: LocalDate, LocalDate -> Boolean</i> | Comprueba si la fecha de los
							datos es correcta.</li>
					</p>
					<p>
						<li><i>selectDate: Boolean, Boolean, LocalDate -> LocalDate</i> | Método que interacciona con el
							usuario pidiéndole una fecha que desee seleccionar y que dependiendo si la elección es un
							periodo de tiempo o en una fecha determinada solicita introducir una o dos fechas.</li>
					</p>
					<p>
						<li><i>askDate: -> String</i> | Método que pregunta al usuario si quiere escoger una fecha
							específica o un periodo de tiempo para mostrarle los datos en función de lo escogido.</li>
					</p>
					<p>
						<li><i>getDates: Int -> Arrray[LocalDate]</i> | Método que recoge las fechas entre la fecha
							inicial y final seleccionadas por el usuario.</li>
					</p>
					<p>
						<li><i>askForWhat: -> Int</i> | Método que permite al usuario seleccionar la opción que quiere
							ver de los datos. Las opciones son: Nacionales, Comunidades y Nacionales VS Comunidades.
						</li>
					</p>
					<p>
						<li><i>getWhereToShowGraphics:</i> | Método que elige la información seleccionada, las fechas
							seleccionadas y el campo.</li>
					</p>
					<p>
						<li><i>askForElement: -> String</i> | Método que interactúa con el usuario preguntándole que
							elemento quiere dibujar en gráfica.</li>
					</p>
					<p>
						<li><i>timeSerieGraphic: Table, String</i> | Método que genera gráficas a partir de las columnas
							de Casos, Altas, PCR+, TestAc+, Hospitalizados, UCI, Fallecidos.</li>
					</p>
					<p>
						<li><i>getTableForGraphic: Int, LocalDate, LocalDate -> Table</i> | Método que genera gráficas a
							partir de las tablas.</li>
					</p>
					<p>
						<li><i>generateCommunityTimeSerieGraphic: ArrayBuffer[String], LocalDate, LocalDate -> Table: ->
								String</i> | Método que genera gráficas a partir de la tabla de los datos nacionales.
						</li>
					</p>
					<p>
						<li><i>drawBarPlot: Table, Int, String</i> | Método que muestra una tabla gráfica con la media,
							el máximo y el total de los datos seleccionados.</li>
					</p>
					<p>
						<li><i>getWhatToCalculate: Boolean</i> | Método que calcula mediante las tablas todas las
							funciones posibles mencionadas.</li>
					</p>

					</p>
					<h3>5.4 Main.scala</h3>
					<p class="text-justify">
						La clase Main nos sirve para ejecutar el proyecto. Solo tendrá la siguiente función:
					<p>
						<li><i>main: args: Array[String] | Permite ejecutar el programa.</i></li>
					</p>

					</p>
				</div>
			</div>
		</div>



		<span class="index-number" id="6"></span>
		<div class="content even-content">
			<div class="row justify-content-center">
				<div class="col-10">
					<h2 class="title-section">6. Comparacion de los prototipos</h2>
					<p class="text-justify"></p>
					<table class="table table-light table-striped">
						<tr>
							<th scope="col">Criterio</th>
							<th scope="col">Prototipo A</th>
							<th scope="col">Prototipo B</th>
							<th scope="col">Comentarios</th>

						</tr>
						<tr>
							<td>Número de criterio 1: Horas de desarrollo de prototipo</td>
							<td>40</td>
							<td>62</td>
							<td>Debido a que Scala es un lenguaje el cual mezcla el paradigma orientado a objetos y el
								paradigma funcional, el tiempo de aprendizaje para los alumnos que solo han utilizado la
								programación orientada a objetos es considerablemente mayor, con 22 horas de diferencia.
								<br>
								El hecho de aprender un nuevo paradigma ha hecho que el tiempo de aprendizaje sea mayor,
								ya que también se le suma el tener que aprender un nuevo lenguaje. </td>
						</tr>
						<tr>
							<td>Número de criterio 2: Tiempo de compilación</td>
							<td>7 seg 547 mls</td>
							<td>6 seg 50 mls</td>
							<td>En la anterior práctica se vio en un pequeño programa que el tiempo de compilación de
								Scala era mucho mayor. Sin embargo, se puede observar que ahora el tiempo de compilación
								es mayor que Kotlin, lo cual se debe a que en Scala el planteamineto del cálculo de los
								datos diarios es mucho más compacto y el uso de funciones anónimas ha ayudado a una
								compilación más rápida. <br>
								En resumen, gracias al uso de la programación funcional el código es más consistente y
								por ende, es más eficiente a la hora de compilar.</td>
						</tr>
						<tr>
							<td>Número de criterio 3: Tiempo de cálculo de los análisis estadísticos</td>
							<td>65 ms</td>
							<td>54 ms</td>
							<td>Para la muestra se ha escogido la combinación de decisiones (1-1-3-3). <br>
								Aunque Scala muestra un mejor rendimiento vemos que la diferencia es apenas de 9
								milisegundos ya que una vez calculados los datos diarios, al utilizar la misma libreria
								y al correr ambos usando el bytecode y la misma máquina virtual, a la hora de calcular
								los datos estadísticos apenas hay diferencia. <br>
								Cabe mencionar que estos son los resultados de ejecutar esta combinación por primera
								vez. Después, si se sigue el mismo camino, se ejecutará mucho más rápido ya que tiene el
								resultado en memoria.
							</td>
						</tr>
						<tr>
							<td>Número de criterio 4: Tiempo de cálculo de datos diarios</td>
							<td>432 ms</td>
							<td>211 ms</td>
							<td>Como las formas de plantear el cálculo diario es distinto tanto en Scala como en Kotlin,
								y en Scala se ha hecho especial énfasis en la programación funcional, el tiempo de
								cálculo de Scala es mucho menor que el de Kotlin. </td>
						</tr>
						<tr>
							<td>Número de criterio 5: Tamaño de los archivos compilados </td>
							<td>32 kb</td>
							<td>49 kb</td>
							<td>En Scala es mayor debido a que el número de archivos compilados generados es mayor.</td>
						</tr>
						<tr>
							<td>Número de criterio 6: Memoria utilizada durante los cálculos estadíticos</td>
							<td>168 MB * 1024 KB/MB</td>
							<td>81 MB * 1024 KB/MB</td>
							<td>La muestra escogida para este criterio es la combinación (1-1-3-3).<br>
								La razón por la que al hacer los análisis estadísticos es porque el planteamiento de la
								manipulación de los datos de las tablas es más conciso (aunque más complejo de entender)
								que Kotlin, implicando un menor uso de memoria. </td>
						</tr>
						<tr>
							<td>Número de criterio 7: Memoria utilizada durante los cálculos diarios</td>
							<td>264MB * 1024 KB/MB</td>
							<td>75 MB * 1024 KB/MB</td>
							<td>Como consecuencia del planteamiento y el mayor número de llamadas a métodos en Kotlin,
								la memoria empleada es considerablemente mayor en este último lenguaje teniendo que
								almacenar en caché muchos más datos que en Scala. </td>
						</tr>
						<tr>
							<td>Número de criterio 8: Memoria utilizada durante la ejecución compleja del programa</td>
							<td>364 MB * 1024 KB/MB</td>
							<td>275 MB * 1024 KB/MB</td>
							<td>Para la ejecución compleja se han empleado tres combinaciones distintas: <br>
								(1-1-3-3)<br>
								(1-1-2-1-fecha(03-20)-fecha(04-20)-T)<br>
								(2-2-3-3-1-T)<br>
								Como se mencionó en anteriores comentarios la lógica más compleja pero más compacta de
								Scala implica un mayor rendimiento y eficiencia a la hora de calcular los datos y por
								ende un mejor uso de la memoria. </td>
						</tr>
						<tr>
							<td>Número de criterio 9: Líneas de código </td>
							<td>641</td>
							<td>553</td>
							<td>Gracias al uso del paradigma funcional y de los aspectos particulares de Scala las
								líneas de código empleadas para el mismo producto software son menores. </td>
						</tr>
						<tr>
							<td>Número de criterio 10: Número de archivos compilados generados</td>
							<td>3</td>
							<td>8</td>
							<td>Al utilizar en Scala la palabra reservada <i> Object</i> en lugar de <i>Class</i> se han
								generado dos archivos compilados por archivo SCALA. La razón es que <i>Object</i> se
								podría considerar como una única instancia, es decir, no se pueden generar instancias a
								partir de ella y todos los métodos y variables (que no sean privadas) se deben de llamar
								desde el propio <i>Object</i>.
								Ahora, para darle más flexibilidad y operabilidad al código de Scala se genera para los
								<i>Object</i> otro archivo compilado para que en caso de utilizar el código en un
								proyecto Java pueda tratarlo como si fuese una clase estática propia de Java.</td>
						</tr>
						<tr>
							<td>Número de criterio 11: Tiempo de Segunda Compilación</td>
							<td>3s 845 ms</td>
							<td>7s 194ms</td>
							<td>Debido a los procesos internos de computación de Kotlin el código se compila
								directamente al byte de JVM. Por el contrario, en Scala se compila en un formato
								intermedio y después al byte JVM. Dado que las compilaciones siguientes a al primera son
								incrementales (solo se recompila el código nuevo) Kotlin compila a byte los fragmentos
								necesarios mientras que Scala recompila siguiendo los dos pasos. </td>
						</tr>
					</table>
				</div>
			</div>
		</div>


		<span class="index-number" id="7"></span>
		<div class="content not-even-content align-items-center container-fluid">
			<div class="row">
				<div class="col-10">
					<h2 class="title-section">7. Conclusiones</h2>
					<p class="text-justify">
						Como conclusión de este trabajo, durante el proceso seguido desde el planteamiento del proyecto
						hasta las comparaciones
						entre el comportamiento de Scala y Kotlin sobre JVM, se ha visto como ambos tienen sus ventajas
						e incovenientes.<br>
						Respecto a las ventajas de Kotlin:

					<ul>
						<li>Es un lenguaje que para la persona que se ha iniciado y que sobre todo esté familiarizado
							con el paradigma orientado a
							objetos, es muy sencillo de asimilar, reduciendo mucho el tiempo de aprendizaje y
							limitándose sólo a sus peculiaridades.</li>
						<li>Tiene seguridad sobre nulos, esto implica, por lo que es menos propenso a fallos.</li>
						<li>La programación es mucho más moderna que Java y Scala.</li>
						<li>Se realiza el mismo trabajo que en Java con menos líneas.</li>
						<li>Familiaridad con el bytecode de JVM.</li>
						<li>Totalmente compatible con Java.</li>
					</ul>
					En cuanto a las desventajas de Kotlin:
					<ul>
						<li>Ocupa más memoria, implicando un tamaño extra de ejecución</li>
						<li>Comunidad de soporte menor que Java y Scala.</li>
						<li>Si se hace un uso muy grande de la sobrecarga de operadores se puede llegar a un código
							ilegible.</li>
					</ul>

					Respecto a las ventajas de Scala:
					<ul>
						<li>Proporciona un código más compacto y elegante, además de organizado.</li>
						<li>El compilador está hecho para ser flexible en cuanto a abstracciones, dejando al programador
							tan sólo la tarea de
							codificar y compilar.</li>
						<li>El hecho de que Scala trabaje con información inmutable simplifica muchos las cosas.</li>
						<li>Es muy ligero una vez se está ejecutando, ocupando mucha menos memoria que Kotlin para
							realizar el mismo trabajo.</li>
						<li>Su carácter híbrido de POO y Programación Funcional hace que muchas de las tareas se
							simplifiquen.</li>
					</ul>
					En cuanto a las desventajas de Scala:
					<ul>
						<li>Tiempo de compilación muy lento.</li>
						<li>Apenas tiene una gestión de los datos nulos.</li>
						<li>Tiene una complejidad de aprendizaje inicial más elevado que Kotlin, lo cual se refleja en
							el tiempo empleado en cada
							proyecto por los alumnos, siendo el de Scala considerablemente mayor.</li>
						<li></li>
					</ul>
					<p class="text-justify">
						Por último, a nivel de docencia, en este proyecto hemos sido capaces de plantear un proyecto,
						ponernos de acuerdo,
						organizarnos y llevar una buena trazabilidad en todo momento, hasta desarrollar todas las
						funcionalidades que nos
						habíamos planteado en un principio. En este último trabajo se ha comprobado que ya nos hemos
						familiarizado casi por
						completo con la metodología Scrum a través de Gitlab y Git, y una vez nos hemos acostumbrado,
						hemos comprendido el
						porqué de su popularidad y el hecho de proponernos retos pequeños para terminar desarrollando un
						proyecto completo, de
						forma mucho más organizada y limpia.
					</p>
					</p>
				</div>
			</div>
		</div>
	</div>

</body>

<script type="text/javascript">
	$('#element').toast('hide')
	var btn = document.getElementsByClassName('to-copy');
	var clipboard = new ClipboardJS(btn);
	clipboard.on('success', function (e) {
		console.log(e);
		$('.toast').toast('show')

	});
	clipboard.on('error', function (e) {
		console.log(e);
	});



</script>



</html>